﻿@model List<ChatMessage>

@{
    ViewData["Title"] = "Chat";
}
<h1>@ViewData["Title"]</h1>


<div class="row">
    <ul id="ul-messages" class="w-75 list-group" style="height: 600px; max-height: 600px; overflow: auto">
        @if (Model != null)
        {
            @foreach (var message in Model)
            {
                <li class="list-group-item">
                    @message.Timestamp @message.Author @message.Text
                </li>
            }
        }
    </ul>
    <div class="w25"></div>
</div>
<div class="row">
    <div class="col">
        <input type="text" name="message" id="message" autocomplete="off">
        <input type="button" class="btn btn-primary" id="send" value="send" />
    </div>
</div>





@section scripts {
    <script src='https://cdnjs.cloudflare.com/ajax/libs/aspnet-signalr/1.0.27/signalr.min.js'></script>

    <script>

        function scrollLast() {
            $("#ul-messages").animate({ scrollTop: $("#ul-messages")[0].scrollHeight }, 1000);
        }

        $("#send").on("click", function (event) {

            if ($(this).hasClass('disabled')) {
                return false;
            }

            $("#send").addClass('disabled');

            var content = $("#message").val();

            var dados = JSON.stringify({
                Message: content,
            })

            $.ajax({
                url: '@Url.Action("PostMessage", "Chat")',
                type: "POST",
                data: dados,
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    $("#message").val('').trigger("input");
                },
                error: function (xhRequest, ErrorText, thrownError) {
                    alert("Failed post message.");
                    console.log('xhRequest: ' + xhRequest + "\n");
                    console.log('ErrorText: ' + ErrorText + "\n");
                    console.log('thrownError: ' + thrownError + "\n");
                }
            });

            

            event.preventDefault();
        });

        $("#message").on("input", function (event) {
            if ($("#message").val().trim() === '') {
                $("#send").addClass('disabled');
            } else {
                $("#send").removeClass('disabled');
            }
        });

        $("#message").val('').trigger("input");

        $("#message").focus();

        $("#message").on("keydown", function (event) {
            if (event.keyCode === 13) {
                $("#send").click();
                $("#message").focus();
            }
        });

        var connection = new signalR.HubConnectionBuilder()
            .withUrl("/chathub")
            .build();

        var _connectionId = '';

        connection.on("ReceiveMessage", function (user, message) {

            var li = $("<li></li>").text(user + ": " + message);
            li.addClass("list-group-item");
            $("#ul-messages").append(li);

            scrollLast();

        });

        connection.start()
            .then(function () {
                @*connection.invoke('joinRoom', '@Model.Id');*@
            })
            .catch(function (err) {
                console.log(err)
            });

        window.addEventListener('onunload', function () {
            @*connection.invoke('leaveRoom', '@Model.Id');*@
            Console.log('Usuário deixou a sala');
        })

        scrollLast();

    </script>
}
